program cup_schedule_checker;
{$APPTYPE CONSOLE}
{$r+}

uses
  testlib;

const 
  nMax = 64;

var
  n, t, i, j, oldIndex, newIndex: integer;
  wm: array[0..nMax, 0..nMax] of integer;
  s, counters: array[0..nMax] of integer;

begin
  n := inf.readInteger;
  t := inf.readInteger;
  for i := 0 to n - 1 do
    for j := 0 to n - 1 do wm[i, j] := inf.readInteger;

  s[0] := ouf.readInteger;
  if s[0] = -1 then Quit(_WA, 'There is always a solution, but participant did not find it');

  for i := 1 to n - 1 do s[i] := ouf.readInteger;

  for i := 0 to n - 1 do
    if (s[i] < 0) or (s[i] >= n) then Quit(_WA, 'Participant answer contains indexes which are out of range');

  for i := 0 to n - 1 do inc(counters[s[i]]);
  for i := 0 to n - 1 do
    if counters[i] <> 1 then Quit(_WA, 'Participant answer does not form a permutation');

  while n > 1 do
  begin
    newIndex := 0;
    oldIndex := 0;
    while oldIndex < n do
    begin
      if wm[s[oldIndex], s[oldIndex + 1]] = 1 then
        s[newIndex] := s[oldIndex]
      else
        s[newIndex] := s[oldIndex + 1];
      inc(oldIndex, 2);
      inc(newIndex);
    end;

    n := n div 2;
  end;

  if s[0] = t then 
    Quit(_OK, 'Participant found good solution')
  else
    Quit(_WA, 'Champion did not make it');
end.
